// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UIComponent.hpp"

using namespace Dawn;

std::vector<std::shared_ptr<UIComponent>> UIComponent::getChildren() {
  return {};
}

void UIComponent::getQuads(
  const struct UIAlign alignment,
  UICanvas &ctx
) {
  auto selfAlignment = getSelfAlignment(alignment);
  this->getSelfQuads(selfAlignment, ctx);

  auto children = getChildren();
  for(auto &c : children) {
    c->getQuads(selfAlignment, ctx);
  }
}

struct UIAlign UIComponent::getSelfAlignment(const struct UIAlign alignment) {
  return (struct UIAlign){
    alignment.position + position,
    alignment.size
  };
}